From c082c835672d41b9a68d1d3195fe0c44cb689fd7 Mon Sep 17 00:00:00 2001
From: Julien Rische <jrische@redhat.com>
Date: Thu, 19 Jan 2023 19:22:27 +0100
Subject: [PATCH 04/21] FIPS: Allow KRB5KDF, MD5, MD4 and HMAC-MD4/5

OpenSSL's restrictions to use KRB5KDF, MD5, and MD4 in FIPS mode are
bypassed in case AES SHA-1 HMAC or RC4 encryption types are allowed by
the crypto policy.

To ensure RC4 HMAC-MD5 was not used in FIPS mode, access to HMAC-MD4/5
was not allowed in this mode. However, since we provide the
"radius_md5_fips_override" configuration parameter to allow using RADIUS
regardless to the FIPS restrictions, we should allow HMAC-MD5 to be used
too in this case, because it is required for the newly supported
Message-Authenticator attribute.

A FIPS mode check is added in calculate_mac() which will fail if
"radius_md5_fips_override" is not true. It will not affect interactions
between krb5kdc and ipa-otpd, because the Message-Authenticator
attribute is not generated in this case.

Last-updated: krb5-1.22.1
Forward-ported-by: Andreas Schneider <asn@redhat.com>
---
 src/lib/crypto/krb/crypto_int.h               |   9 ++
 src/lib/crypto/openssl/Makefile.in            |   9 +-
 src/lib/crypto/openssl/common.c               | 105 ++++++++++++++++++
 .../crypto/openssl/hash_provider/hash_evp.c   |  45 ++++++--
 src/lib/crypto/openssl/hmac.c                 |  14 ++-
 src/lib/crypto/openssl/kdf.c                  |   2 +-
 src/lib/krad/packet.c                         |  19 ++--
 src/lib/krad/remote.c                         |   6 +-
 8 files changed, 180 insertions(+), 29 deletions(-)
 create mode 100644 src/lib/crypto/openssl/common.c

diff --git a/src/lib/crypto/krb/crypto_int.h b/src/lib/crypto/krb/crypto_int.h
index 3629616d96..0e6263bf15 100644
--- a/src/lib/crypto/krb/crypto_int.h
+++ b/src/lib/crypto/krb/crypto_int.h
@@ -36,6 +36,9 @@
 
 #include <openssl/opensslv.h>
 #if OPENSSL_VERSION_NUMBER >= 0x30000000L
+
+#include <openssl/provider.h>
+
 /*
  * OpenSSL 3.0 relegates MD4 and RC4 to the legacy provider, which must be
  * explicitly loaded into a library context.  Performing this loading within a
@@ -671,4 +674,10 @@ iov_cursor_advance(struct iov_cursor *c, size_t nblocks)
     c->out_pos += nblocks * c->block_size;
 }
 
+#if OPENSSL_VERSION_NUMBER >= 0x30000000L
+
+krb5_error_code k5_get_ossl_legacy_libctx(OSSL_LIB_CTX **libctx);
+
+#endif /* OPENSSL_VERSION_NUMBER >= 0x30000000L */
+
 #endif /* CRYPTO_INT_H */
diff --git a/src/lib/crypto/openssl/common.c b/src/lib/crypto/openssl/common.c
new file mode 100644
index 0000000000..144346c231
--- /dev/null
+++ b/src/lib/crypto/openssl/common.c
@@ -0,0 +1,105 @@
+/*
+ * OpenSSL 3.0 Legacy Provider Support
+ *
+ * OpenSSL 3.0 moved older cryptographic algorithms (MD4, MD5, RC4) to a
+ * separate "legacy provider" that must be explicitly loaded. These algorithms
+ * are considered deprecated but are still needed for backward compatibility:
+ *
+ *   - MD4/MD5: Used by older Kerberos encryption types and RADIUS
+ *   - RC4: Used by RC4-HMAC encryption type
+ *   - HMAC-MD5: Required for RADIUS Message-Authenticator attribute
+ *
+ * In FIPS mode, these algorithms are normally blocked. However, when the
+ * "radius_md5_fips_override" configuration option is enabled, we need to
+ * allow HMAC-MD5 for RADIUS compatibility. This module provides a shared
+ * OpenSSL library context with the legacy provider loaded, enabling access
+ * to these algorithms when explicitly required.
+ *
+ * The context is stored in thread-local storage to avoid concurrency issues.
+ */
+
+#include "crypto_int.h"
+
+#include <openssl/provider.h>
+#include <openssl/evp.h>
+#include <threads.h>
+#include <stdbool.h>
+
+/* Thread-local context holding the OpenSSL legacy provider state. */
+typedef struct ossl_legacy_context {
+    bool initialized;
+    OSSL_LIB_CTX *libctx;
+    OSSL_PROVIDER *default_provider;
+    OSSL_PROVIDER *legacy_provider;
+} ossl_legacy_context_t;
+
+static thread_local ossl_legacy_context_t g_ossl_legacy_ctx;
+
+/* Initialize an OpenSSL library context with both default and legacy providers. */
+static krb5_error_code
+init_ossl_legacy_ctx(ossl_legacy_context_t *ctx)
+{
+    ctx->libctx = OSSL_LIB_CTX_new();
+    if (!ctx->libctx)
+        return KRB5_CRYPTO_INTERNAL;
+
+    /* Load both legacy and default provider as both may be needed. */
+    ctx->default_provider = OSSL_PROVIDER_load(ctx->libctx, "default");
+    ctx->legacy_provider = OSSL_PROVIDER_load(ctx->libctx, "legacy");
+
+    if (!(ctx->default_provider && ctx->legacy_provider))
+        return KRB5_CRYPTO_INTERNAL;
+
+    ctx->initialized = true;
+    return 0;
+}
+
+static void
+deinit_ossl_legacy_ctx(ossl_legacy_context_t *ctx)
+{
+    if (ctx->legacy_provider)
+        OSSL_PROVIDER_unload(ctx->legacy_provider);
+
+    if (ctx->default_provider)
+        OSSL_PROVIDER_unload(ctx->default_provider);
+
+    if (ctx->libctx)
+        OSSL_LIB_CTX_free(ctx->libctx);
+
+    ctx->initialized = false;
+}
+
+/*
+ * Get an OpenSSL library context with the legacy provider loaded.
+ *
+ * In non-FIPS mode, returns NULL (use the default context).
+ * In FIPS mode, returns a dedicated context with the legacy provider,
+ * allowing access to deprecated algorithms like MD4/MD5 when explicitly needed.
+ */
+krb5_error_code
+k5_get_ossl_legacy_libctx(OSSL_LIB_CTX **libctx)
+{
+    krb5_error_code err;
+
+    if (!EVP_default_properties_is_fips_enabled(NULL)) {
+        if (libctx)
+            *libctx = NULL;
+        err = 0;
+        goto end;
+    }
+
+    if (!g_ossl_legacy_ctx.initialized) {
+        err = init_ossl_legacy_ctx(&g_ossl_legacy_ctx);
+        if (err) {
+            deinit_ossl_legacy_ctx(&g_ossl_legacy_ctx);
+            goto end;
+        }
+    }
+
+    if (libctx)
+        *libctx = g_ossl_legacy_ctx.libctx;
+    err = 0;
+
+end:
+    return err;
+}
diff --git a/src/lib/crypto/openssl/hash_provider/hash_evp.c b/src/lib/crypto/openssl/hash_provider/hash_evp.c
index 11659908bb..498967d07c 100644
--- a/src/lib/crypto/openssl/hash_provider/hash_evp.c
+++ b/src/lib/crypto/openssl/hash_provider/hash_evp.c
@@ -60,11 +60,6 @@ hash_evp(const EVP_MD *type, const krb5_crypto_iov *data, size_t num_data,
     if (ctx == NULL)
         return ENOMEM;
 
-    if (type == EVP_md4() || type == EVP_md5()) {
-        /* See comments below in hash_md4() and hash_md5(). */
-        EVP_MD_CTX_set_flags(ctx, EVP_MD_CTX_FLAG_NON_FIPS_ALLOW);
-    }
-
     ok = EVP_DigestInit_ex(ctx, type, NULL);
     for (i = 0; i < num_data; i++) {
         if (!SIGN_IOV(&data[i]))
@@ -77,6 +72,32 @@ hash_evp(const EVP_MD *type, const krb5_crypto_iov *data, size_t num_data,
     return ok ? 0 : KRB5_CRYPTO_INTERNAL;
 }
 
+static krb5_error_code
+hash_legacy_evp(const char *algo, const krb5_crypto_iov *data, size_t num_data,
+                krb5_data *output)
+{
+    krb5_error_code err;
+    OSSL_LIB_CTX *ossl_libctx;
+    EVP_MD *md = NULL;
+
+    err = k5_get_ossl_legacy_libctx(&ossl_libctx);
+    if (err)
+        goto end;
+
+    md = EVP_MD_fetch(ossl_libctx, algo, NULL);
+    if (!md) {
+        err = KRB5_CRYPTO_INTERNAL;
+        goto end;
+    }
+
+    err = hash_evp(md, data, num_data, output);
+
+end:
+    if (md)
+        EVP_MD_free(md);
+
+    return err;
+}
 #endif
 
 #ifdef K5_OPENSSL_MD4
@@ -88,7 +109,9 @@ hash_md4(const krb5_crypto_iov *data, size_t num_data, krb5_data *output)
      * by IPA.  These keys are only used along a (separately) secured channel
      * for legacy reasons when performing trusts to Active Directory.
      */
-    return hash_evp(EVP_md4(), data, num_data, output);
+    return EVP_default_properties_is_fips_enabled(NULL)
+        ? hash_legacy_evp("MD4", data, num_data, output)
+            : hash_evp(EVP_md4(), data, num_data, output);
 }
 
 const struct krb5_hash_provider krb5int_hash_md4 = {
@@ -100,9 +123,13 @@ const struct krb5_hash_provider krb5int_hash_md4 = {
 static krb5_error_code
 hash_md5(const krb5_crypto_iov *data, size_t num_data, krb5_data *output)
 {
-    /* MD5 is needed in FIPS mode for communication with RADIUS servers.  This
-     * is gated in libkrad by libdefaults->radius_md5_fips_override. */
-    return hash_evp(EVP_md5(), data, num_data, output);
+    /*
+     * MD5 is needed in FIPS mode for communication with RADIUS servers.  This
+     * is gated in libkrad by libdefaults->radius_md5_fips_override.
+     */
+    return EVP_default_properties_is_fips_enabled(NULL)
+        ? hash_legacy_evp("MD5", data, num_data, output)
+            : hash_evp(EVP_md5(), data, num_data, output);
 }
 
 const struct krb5_hash_provider krb5int_hash_md5 = {
diff --git a/src/lib/crypto/openssl/hmac.c b/src/lib/crypto/openssl/hmac.c
index bfbbc53fd2..945586a525 100644
--- a/src/lib/crypto/openssl/hmac.c
+++ b/src/lib/crypto/openssl/hmac.c
@@ -111,11 +111,7 @@ map_digest(const struct krb5_hash_provider *hash)
         return EVP_sha256();
     else if (hash == &krb5int_hash_sha384)
         return EVP_sha384();
-
-    if (EVP_default_properties_is_fips_enabled(NULL))
-        return NULL;
-
-    if (hash == &krb5int_hash_md5)
+    else if (hash == &krb5int_hash_md5)
         return EVP_md5();
     else if (hash == &krb5int_hash_md4)
         return EVP_md4();
@@ -137,13 +133,19 @@ krb5int_hmac_keyblock(const struct krb5_hash_provider *hash,
     EVP_MAC_CTX *ctx = NULL;
     OSSL_PARAM params[2], *p = params;
     size_t i = 0, md_len;
+    OSSL_LIB_CTX *ossl_libctx;
+    krb5_error_code err;
 
     if (md == NULL || keyblock->length > hash->blocksize)
         return KRB5_CRYPTO_INTERNAL;
     if (output->length < hash->hashsize)
         return KRB5_BAD_MSIZE;
 
-    mac = EVP_MAC_fetch(NULL, "HMAC", NULL);
+    err = k5_get_ossl_legacy_libctx(&ossl_libctx);
+    if (err)
+        return err;
+
+    mac = EVP_MAC_fetch(ossl_libctx, "HMAC", NULL);
     if (mac == NULL)
         return KRB5_CRYPTO_INTERNAL;
 
diff --git a/src/lib/crypto/openssl/kdf.c b/src/lib/crypto/openssl/kdf.c
index 41e845eae0..2713850997 100644
--- a/src/lib/crypto/openssl/kdf.c
+++ b/src/lib/crypto/openssl/kdf.c
@@ -200,7 +200,7 @@ k5_derive_random_rfc3961(const struct krb5_enc_provider *enc, krb5_key key,
         goto done;
     }
 
-    kdf = EVP_KDF_fetch(NULL, "KRB5KDF", NULL);
+    kdf = EVP_KDF_fetch(NULL, "KRB5KDF", "-fips");
     if (kdf == NULL) {
         ret = KRB5_CRYPTO_INTERNAL;
         goto done;
diff --git a/src/lib/krad/packet.c b/src/lib/krad/packet.c
index 7e4fd72203..a04b6b57f9 100644
--- a/src/lib/krad/packet.c
+++ b/src/lib/krad/packet.c
@@ -275,7 +275,7 @@ lookup_msgauth_addr(const krad_packet *pkt)
  * auth, which may be from pkt or from a corresponding request.
  */
 static krb5_error_code
-calculate_mac(const char *secret, const krad_packet *pkt,
+calculate_mac(krb5_context ctx, const char *secret, const krad_packet *pkt,
               const uint8_t auth[AUTH_FIELD_SIZE],
               uint8_t mac_out[MD5_DIGEST_SIZE])
 {
@@ -286,6 +286,10 @@ calculate_mac(const char *secret, const krad_packet *pkt,
         KRAD_ATTR_MESSAGE_AUTHENTICATOR, MSGAUTH_SIZE
     };
 
+    /* Do not use HMAC-MD5 if not explicitly allowed */
+    if (kr_use_fips(ctx))
+        return KRB5_CRYPTO_INTERNAL;
+
     msgauth_attr = lookup_msgauth_addr(pkt);
     if (msgauth_attr == NULL)
         return EINVAL;
@@ -387,7 +391,8 @@ krad_packet_new_request(krb5_context ctx, const char *secret, krad_code code,
 
     if (msgauth_required) {
         /* Calculate and set the Message-Authenticator MAC. */
-        retval = calculate_mac(secret, pkt, pkt_auth(pkt), pkt_attr(pkt) + 2);
+        retval = calculate_mac(ctx, secret, pkt, pkt_auth(pkt),
+                               pkt_attr(pkt) + 2);
         if (retval != 0)
             goto error;
     }
@@ -448,7 +453,7 @@ krad_packet_new_response(krb5_context ctx, const char *secret, krad_code code,
          * section 5.14, use the authenticator from the request, not from the
          * response.
          */
-        retval = calculate_mac(secret, pkt, pkt_auth(request),
+        retval = calculate_mac(ctx, secret, pkt, pkt_auth(request),
                                pkt_attr(pkt) + 2);
         if (retval != 0)
             goto error;
@@ -470,7 +475,7 @@ error:
 /* Verify the Message-Authenticator value in pkt, using the provided
  * authenticator (which may be from pkt or from a corresponding request). */
 static krb5_error_code
-verify_msgauth(const char *secret, const krad_packet *pkt,
+verify_msgauth(krb5_context ctx, const char *secret, const krad_packet *pkt,
                const uint8_t auth[AUTH_FIELD_SIZE])
 {
     uint8_t mac[MD5_DIGEST_SIZE];
@@ -481,7 +486,7 @@ verify_msgauth(const char *secret, const krad_packet *pkt,
     if (msgauth == NULL)
         return ENODATA;
 
-    retval = calculate_mac(secret, pkt, auth, mac);
+    retval = calculate_mac(ctx, secret, pkt, auth, mac);
     if (retval)
         return retval;
 
@@ -554,7 +559,7 @@ krad_packet_decode_request(krb5_context ctx, const char *secret,
 
     /* Verify Message-Authenticator if present. */
     if (has_pkt_msgauth(req)) {
-        retval = verify_msgauth(secret, req, pkt_auth(req));
+        retval = verify_msgauth(ctx, secret, req, pkt_auth(req));
         if (retval) {
             krad_packet_free(req);
             return retval;
@@ -606,7 +611,7 @@ krad_packet_decode_response(krb5_context ctx, const char *secret,
 
             /* Verify Message-Authenticator if present. */
             if (has_pkt_msgauth(*rsppkt)) {
-                if (verify_msgauth(secret, *rsppkt, pkt_auth(tmp)) != 0)
+                if (verify_msgauth(ctx, secret, *rsppkt, pkt_auth(tmp)) != 0)
                     continue;
             }
 
diff --git a/src/lib/krad/remote.c b/src/lib/krad/remote.c
index 7654bab21b..96da3c451d 100644
--- a/src/lib/krad/remote.c
+++ b/src/lib/krad/remote.c
@@ -76,10 +76,10 @@ static void
 on_timeout(verto_ctx *ctx, verto_ev *ev);
 
 static in_addr_t get_in_addr(struct addrinfo *info)
-{ return ((struct sockaddr_in *)(info->ai_addr))->sin_addr.s_addr; }
+{ return sa2sin(info->ai_addr)->sin_addr.s_addr; }
 
-static struct in6_addr *get_in6_addr(struct addrinfo *info)
-{ return &(((struct sockaddr_in6 *)(info->ai_addr))->sin6_addr); }
+static const struct in6_addr *get_in6_addr(struct addrinfo *info)
+{ return &sa2sin6(info->ai_addr)->sin6_addr; }
 
 static bool is_inet_localhost(struct addrinfo *info)
 {
-- 
2.53.0


